<?php

//----------------------------------------------------------------------------------
// COMMON DB-QUERIES
//----------------------------------------------------------------------------------
function netblog_getURIDbyName( $uri )
{
	global $wpdb; 
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$uri = addslashes($uri);
	$r = $wpdb->get_row("SELECT * FROM `$ext` WHERE uri = '$uri'",ARRAY_A);
	if( $wpdb->num_rows > 0 ) return $r['uri_id'];
	else return -1;
}
function netblog_isAdjacent( $nodeID, $childNode, $extern = false )
{
	global $wpdb; 
	if($extern) {
		$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
		$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
		$childNode = addslashes($childNode);
		$query = "
			SELECT * FROM `$ext` e, `$rel` r
			WHERE r.uri_id = e.uri_id
			AND r.id = $nodeID
			AND e.uri = '$childNode'
		";
		return $wpdb->get_row($query) != null;
	} else {
		$net = $wpdb->prefix . constant('NETBLOG_DB_NET');
		return $wpdb->get_row("SELECT * FROM `$net` WHERE id = $nodeID AND adj_id = $childNode") != null;
	}
}
function netblog_hasAdjacent( $nodeID, $extern = false )
{
	global $wpdb; 
	if($extern) {
		$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
		return $wpdb->get_row("SELECT * FROM `$rel` WHERE id = $nodeID LIMIT 1") != null;
	} else {
		$net = $wpdb->prefix . constant('NETBLOG_DB_NET');
		return $wpdb->get_row("SELECT * FROM `$net` WHERE id = $nodeID LIMIT 1") != null;
	}
}
function netblog_removeAdjacent( $nodeID, $childNode, $extern = false )
{
	global $wpdb; 
	if($extern){
		$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
		$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
		
		//if( !netblog_hasAdjacent($nodeID,true) ) return false;
		
		$uriID = netblog_getURIDbyName($childNode);
		$res = $wpdb->query("DELETE FROM `$rel` WHERE id = $nodeID AND uri_id = $uriID");
		$wpdb->query("UPDATE `$ext` SET refs = refs-1 WHERE uri_id = $uriID");
		
		if( $wpdb->query("SELECT * FROM `$rel` WHERE uri_id = $uriID") == null )
			$wpdb->query("DELETE FROM `$ext` WHERE uri_id = $uriID");
		
		return !($res == false || $res <= 0);		
	} else {
		$net = $wpdb->prefix . constant('NETBLOG_DB_NET');
		$res = $wpdb->query("DELETE FROM `$net` WHERE id = $nodeID AND adj_id = '$childNode'");
		return !($res == false || $res <= 0);
	} 	
}
function netblog_removeURI( $uri )
{
	global $wpdb;
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
	
	$id = netblog_getURIDbyName($uri);
	$wpdb->query("DELETE FROM `$rel` WHERE uri_id = $id");
	$res = $wpdb->query("DELETE FROM `$ext` WHERE uri_id = $id");
	return !($res == false || $res <= 0);	
}

function netblog_removeURIFromNode( $nodeID, $uri )
{
	return netblog_removeAdjacent($nodeID,$uri,true);
}
function netblog_removeNode( $nodeID )
{
	$adj = netblog_getAdjacents($nodeID, true, true );
	foreach( $adj as $e )
		if( !netblog_removeAdjacent($nodeID,$e['uri'],true) )
			return false;
	return true;
}
function netblog_addAdjacent( $nodeID, $childNode, $extern = false, $uriTitle = '' )
{
	global $wpdb;
	
	if( netblog_isAdjacent($nodeID,$childNode,$extern) )
		return false;
	
	if($extern){		
		$childNode = addslashes($childNode);
		$uriTitle = addslashes( strip_tags($uriTitle) );
		if( strlen($uriTitle) == 0 ) return false;		
		
		$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
		
		$uri_id = netblog_addURI($childNode,$uriTitle);		
		$res = $wpdb->query("INSERT INTO `$rel` (id,uri_id) VALUES ('$nodeID','$uri_id')");
		
		return !($res == false || $res <= 0);
	} else {
		$net = $wpdb->prefix . constant('NETBLOG_DB_NET');
		$res = $wpdb->query("INSERT INTO `$net` (id,adj_id) VALUES ('$nodeID','$childNode')");
		return !($res == false || $res <= 0);
	} 
}
function netblog_getNodesByAdjacent( $childNode, $extern = false )
{
	global $wpdb;
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
			
	if($extern){
		$uri = addslashes($childNode);
		$query = "
			SELECT ext.uri, ext.uri_title, ext.uri_id, p.ID, p.post_title, p.post_date, p.post_status, p.post_type
			FROM `$ext` ext, `$rel` rel, $wpdb->posts p
			WHERE ext.uri = '$uri'
			AND ext.uri_id = rel.uri_id
			AND rel.id = p.id
			ORDER BY p.post_date;
		";
		return $wpdb->get_results($query,ARRAY_A);		
	} else {
		return array();
	}
}
function netblog_getNodesByAdjacentAsString( $childNode, $extern = false, $limit = -1 )
{
	$arr = netblog_getNodesByAdjacent($childNode,$extern);
	if($extern) {
		$num = 0;$out = Array();
		foreach( $arr as $row )
			if( $num++ < $limit || $limit == -1 )
				$out[] = $row['post_title'];
		return implode(', ', $out);
	} else {
		return '';
	}
}

function netblog_updateURI( $uri, $title ) 
{
	global $wpdb;
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$uri = addslashes($uri);
	$uriTitle = addslashes( strip_tags($uriTitle) );
	if( strlen($uriTitle) == 0 ) return false;	
	
	$res = $wpdb->query("UPDATE `$ext` SET uri_title = '$uriTitle' WHERE uri = '$uri'");
	return !($res == false || $res <= 0);
}
function netblog_updateURIbyID( $uri_id, $uri, $title, $flag = -1 ) 
{
	global $wpdb;
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$uri = trim(addslashes($uri));
	$uriTitle = trim(addslashes( strip_tags($title) ));
	if( strlen($uriTitle) == 0 ) return false;	
	
	$res = array();
	if( $flag == -1 || !is_numeric($flag) )
		$res = $wpdb->query("UPDATE `$ext` SET uri_title = '$uriTitle', uri = '$uri' WHERE uri_id = $uri_id");
	else $res = $wpdb->query("UPDATE `$ext` SET uri_title = '$uriTitle', uri = '$uri', flag = '$flag' WHERE uri_id = $uri_id");
	return !($res == false || $res <= 0);
}

function netblog_addURI( $uri, $title )
{
	global $wpdb; 
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$uri = trim(addslashes($uri));
	$uriTitle = trim(addslashes( strip_tags($title) ));
		
	$id = netblog_getURIDbyName($uri);	
	if( $id == -1 ) {
		$wpdb->query("INSERT INTO `$ext` (uri,uri_title) VALUES ('$uri','$title')");
		$id = $wpdb->insert_id;
	} else $wpdb->query("UPDATE `$ext` SET refs = refs+1 WHERE uri_id = $id");
	return $id;		
}
function netblog_getURI( $uri )
{
	global $wpdb; 
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$uri = addslashes($uri);
	return $wpdb->get_row("SELECT * FROM `$ext` WHERE uri = '$uri'", ARRAY_A);
}
function netblog_getAdjacents( $nodeID, $fetchInfos = false, $extern = false )
{
	global $wpdb; 
	
	if($extern){
		$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
		$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
		$childNode = addslashes($childNode);
		$query = "
			SELECT * FROM `$ext` e, `$rel` r
			WHERE r.uri_id = e.uri_id
			AND r.id = $nodeID
			ORDER BY e.uri
		";
		return $wpdb->get_results($query, ARRAY_A);
	} else {
		$net = $wpdb->prefix . constant('NETBLOG_DB_NET');	
		if( !$fetchInfos )
			$query = "
			    SELECT *
			    FROM `$net`
			    WHERE id = $nodeID;
			";
		else 
			$query = "
			    SELECT p.ID, post_title, user_nicename, post_date, post_status, post_type
			    FROM $wpdb->posts p, `$net` n, $wpdb->users u
		      	WHERE n.id = $nodeID
		      	AND n.adj_id = p.ID
		      	AND p.post_author = u.ID
			    AND (p.post_type = 'post' || p.post_type = 'page')
			    ORDER BY p.post_title;
			";																				//UPDT_1.2 - page
		return $wpdb->get_results($query, ARRAY_A);
	}	
}
function netblog_getInfos( $nodeID )
{
	global $wpdb;
	$query = "
	    SELECT p.ID, post_title, user_nicename, post_date, post_status, post_type
	    FROM $wpdb->posts p, $wpdb->users u
      	WHERE p.id = $nodeID
      	AND p.post_author = u.ID
	    AND (p.post_type = 'post' || p.post_type = 'page')
	    ORDER BY p.post_date DESC;
	";																								//UPDT_1.2 - page
	$adjs = $wpdb->get_results($query, ARRAY_A);
	return $adjs;	
}
function netblog_getPostType( $nodeID )
{
	$nd = netblog_getInfos($nodeID);
	return $nd[0]['post_type'];
}

function netblog_updt_post_parse( $k )
{
	return substr($k, strpos($k,'-')+1 );
}







/*
 * URI-DB OPS
 */
function netblog_get_uris( $orderBy, $limit = -1, $flag = NULL, $refs = 0 )
{
	global $wpdb;
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$desc = strtoupper($desc);
	
	// VERIFY
	$q = "SELECT * FROM `$ext`";
	$order = Array();
	$validTbl = array('uri_id'=>'uri_id','id'=>'uri_id','title'=>'uri_title','uri_title'=>'uri_title','refs'=>'refs','flag'=>'flag');
	foreach( $orderBy as $by ) {
		if( is_string($by) ) $by = explode(' ',$by);					
		if( !isset($by[0]) || !isset($validTbl[$by[0]]) || isset($order[$validTbl[$by[0]]]) ) continue;
		
		$t = $validTbl[$by[0]];
		if( isset($by[1]) && strtolower($by[1]) == 'desc' )
			$t .= ' DESC';
		$order[$validTbl[$by[0]]] = $t;
	}
	
	if( $flag != null ) {
		$flagMap = array('online'=>0, 'offline'=>1, 'trash'=>2);
		if( isset($flagMap[$flag]) ) $flag = $flagMap[$flag];
		else $flag = null; 
	}
	
	// BUILD SQL-CMD
	if( $flag != null )
		$q .= " WHERE flag = $flag";
	if( sizeof($order) > 0 )
		$q .= " ORDER BY ".implode(', ',$order);
	if( is_numeric($limit) && $limit > 0 )
		$q .= " LIMIT $limit";
//var_dump($q);
	return $wpdb->get_results($q,ARRAY_A);
}


function netblog_get_uris_match( $match, $orderBy = 'uri_title', $limit = -1, $flag = NULL )
{
	global $wpdb;
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');

	// VERIFY
	$match = addslashes($match);
	$q = "SELECT * FROM `$ext` WHERE uri_title like '%$match%' OR uri like '%$match%'";
	
	$order = Array();
	$validTbl = array('uri_id'=>'uri_id','id'=>'uri_id','title'=>'uri_title','uri_title'=>'uri_title','refs'=>'refs','flag'=>'flag');
	foreach( $orderBy as $by ) {
		if( is_string($by) ) $by = explode(' ',$by);					
		if( !isset($by[0]) || !isset($validTbl[$by[0]]) || isset($order[$validTbl[$by[0]]]) ) continue;
		
		$t = $validTbl[$by[0]];
		if( isset($by[1]) && strtolower($by[1]) == 'desc' )
			$t .= ' DESC';
		$order[$validTbl[$by[0]]] = $t;
	}
	
	if( $flag != null ) {
		$flagMap = array('online'=>0, 'offline'=>1, 'trash'=>2);
		if( isset($flagMap[$flag]) ) $flag = $flagMap[$flag];
		else $flag = null; 
	}
	
	// BUILD SQL-CMD
	if( $flag != null )
		$q .= " AND flag = $flag";
	if( sizeof($order) > 0 )
		$q .= " ORDER BY ".implode(', ',$order);
	if( is_numeric($limit) && $limit > 0 )
		$q .= " LIMIT $limit";
//var_dump($q);			
	return $wpdb->get_results($q,ARRAY_A);
}




?>